//------------------------------------------------------------
//
//------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_width1  2
#property indicator_color2  MediumSeaGreen
#property indicator_color3  MediumSeaGreen
#property indicator_color4  MediumSeaGreen


extern string Symbol1       = "";
extern string Symbol2       = "";
extern int    BandPeriod    = 20;
extern double BandDeviation = 2.00;

double value[];
double bandUp[];
double bandDn[];
double bandMd[];

string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------
//
//------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorDigits(6);
   SetIndexBuffer(0,value);
   SetIndexBuffer(1,bandUp);
   SetIndexBuffer(2,bandDn);
   SetIndexBuffer(3,bandMd);
      if (Symbol1 =="") Symbol1=Symbol();
      if (Symbol2 =="") Symbol2=Symbol();
         indicatorFileName = WindowExpertName();
         returnBars        = (Symbol1=="returnBars"); if (returnBars) return(0);
      IndicatorShortName(Symbol1+" to "+Symbol2+" ratio");
   return(0); 
}
int deinit() { return(0); }

//------------------------------------------------------------
//
//------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { value[0] = limit+1; return(0); }
         if (Symbol1!=Symbol()) limit = MathMax(limit,MathMin(Bars-1,iCustom(Symbol1,0,indicatorFileName,"returnBars",0,0)));
         if (Symbol2!=Symbol()) limit = MathMax(limit,MathMin(Bars-1,iCustom(Symbol2,0,indicatorFileName,"returnBars",0,0)));
                                limit = MathMin(limit,Bars-1);

   //
   //
   //
   //
   //

   for (int i=limit; i>=0; i--)
   {
      double s2 = iClose(Symbol2,0,iBarShift(Symbol2,0,Time[i]));
      if (s2!=0)
            value[i] = iClose(Symbol1,0,iBarShift(Symbol1,0,Time[i]))/s2;
      else  value[i] = value[i+1];
   }
   for (i=limit; i>=0; i--)
   {
      bandMd[i] = iBandsOnArray(value,0,BandPeriod,BandDeviation,0,MODE_MAIN, i);
      bandUp[i] = iBandsOnArray(value,0,BandPeriod,BandDeviation,0,MODE_UPPER,i);
      bandDn[i] = iBandsOnArray(value,0,BandPeriod,BandDeviation,0,MODE_LOWER,i);             
   }
   return(0);
}